RegisterAddonMessagePrefix("ICoor");
ICoorSendType = "OFFICER";
ICoor = CreateFrame("Frame", "ICoor", UIParent, nil);

ICoor.Queue = CreateFrame("Frame", "ICoor_Queue", ICoor, nil);

ICoor.Instructions = CreateFrame("Frame", "ICoor_Instructions", ICoor, nil);

ICoor.InFight = false;

ICoor.Table = {"None", "None", "None", "None", "None"};

ICoor.Globals = {
	SoundFile = "Interface\\AddOns\\InterruptCoordinator\\Textures\\WarningSound.ogg",
	Textures = {
		Flat = "Interface\\AddOns\\InterruptCoordinator\\Textures\\Flat.tga",
		Gradient = "Interface\\AddOns\\InterruptCoordinator\\Textures\\Gradient.tga",
		Text = "Interface\\AddOns\\InterruptCoordinator\\Textures\\ADAMCGPRO.ttf",
	},
	Queue = {
		Size = {150, 100},
		Location = {0, 0},
		AnchorPoint = "TOPLEFT",
		RelativeTo = "ICoor_Instructions",
		RelativePoint = "BOTTOMLEFT",
		Color = {0, 0, 0, 0.5},
		FontColor = {0.8, 0.8, 0.8, 1},
		FontSize = 8,
	},
	Instructions = {
		Size = {150, 25},
		Location = {50, -50},
		AnchorPoint = "TOPLEFT",
		RelativeTo = "UIParent",
		RelativePoint = "TOPLEFT",
		Color = {0, 0, 0, 0.5},
		FontColor = {0.8, 0.8, 0.8, 1},
		BarColor = {1, 0, 0, 1},
		FontSize = 8,
	},
};

function ICoor:ToggleAddon()
	if ICoor_Saves.Queue then
		self.Queue:Show();
	else
		self.Queue:Hide();
	end

	if ICoor_Saves.IsShown then
		self:Show();
	else
		self:Hide();
	end
end

local function OnUpdate(self)
	local start, duration = GetSpellCooldown(ICoor_Saves.InterruptToTrack);
	if duration > 0 then
		SendAddonMessage("ICoor", "cd_" ..GetUnitName("player", false) .."_" ..duration, ICoorSendType);
		self:SetScript("OnUpdate", nil);
	end
end

local function OnEvent(self, event, arg1, arg2)
	if event == "CHAT_MSG_ADDON" then
		words = {}
		for word in arg2:gmatch("([^_]+)") do table.insert(words, word) end
		if words[1] == "join" then
			self.Queue:Join(words[2]);
			ICoor.Instructions:Update();
		elseif words[1] == "leave" then
			self.Queue:Leave(words[2]);
			ICoor.Instructions:Update();
		elseif words[1] == "jump" then
			self.Queue:Jump(words[2], words[3]);
			ICoor.Instructions:Update();
		elseif words[1] == "list" then
			self.Queue:Load(words[2], words[3], words[4], words[5], words[6]);
			ICoor.Instructions:Update();
		elseif words[1] == "fight" then
			self.Instructions:LoadName(words[2]);
			self.Queue:Load(words[3], words[4], words[5], words[6], words[7]);
			for i = 3, 7 do
				if words[i] == GetUnitName("player", false) then
					self.InFight = true;
				end
			end
			ICoor.Instructions:Update();
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		if arg1 == "player" then
			if self.InFight then
				if arg2 == ICoor_Saves.InterruptToTrack then
					self:SetScript("OnUpdate", OnUpdate);
				end
			end
		end
	elseif event == "ADDON_LOADED" then
		if arg1 == "InterruptCoordinator" then
			if ICoor_Saves == nil then
				ICoor_Saves = {};
				local class = UnitClass("player");
				if class == "Shaman" then ICoor_Saves.InterruptToTrack = "Wind Shear" end
				if class == "Druid" then ICoor_Saves.InterruptToTrack = "Skull Bash" end
				if class == "Hunter" then ICoor_Saves.InterruptToTrack = "Counter Shot" end
				if class == "Mage" then ICoor_Saves.InterruptToTrack = "Counterspell" end
				if class == "Paladin" then ICoor_Saves.InterruptToTrack = "Rebuke" end
				if class == "Priest" then ICoor_Saves.InterruptToTrack = "Silence" end
				if class == "Rogue" then ICoor_Saves.InterruptToTrack = "Kick" end
				if class == "Warlock" then ICoor_Saves.InterruptToTrack = "Spell Lock" end
				if class == "Warrior" then ICoor_Saves.InterruptToTrack = "Pummel" end
				if class == "Death Knight" then ICoor_Saves.InterruptToTrack = "Mind Freeze" end
				ICoor_Saves.Queue = true;
				ICoor_Saves.Locked = true;
				ICoor_Saves.IsShown = true;
				ICoor_Saves.Position = {
					AnchorPoint = "TOPLEFT",
					RelativeTo = "UIParent",
					RelativePoint = "TOPLEFT",
					Location = {50, -50},
				};
				ICoor_Saves.Playsound = true;
			end
			ICoor.Globals.Instructions.AnchorPoint = ICoor_Saves.Position.AnchorPoint;
			ICoor.Globals.Instructions.RelativeTo = ICoor_Saves.Position.RelativeTo;
			ICoor.Globals.Instructions.RelativePoint = ICoor_Saves.Position.RelativePoint;
			ICoor.Globals.Instructions.Location = ICoor_Saves.Position.Location;
			self.LoadQueue();
			self.LoadInstructions();
		end
	end
end
ICoor:RegisterEvent("CHAT_MSG_ADDON");
ICoor:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
ICoor:RegisterEvent("ADDON_LOADED");
ICoor:SetScript("OnEvent", OnEvent);