local config = CreateFrame("Frame");
ICoorM = CreateFrame("Frame", "ICoorM", UIParent, nil);
ICoorM.CurrentFight = {
	Name = "New Fight",
	Spell = "Ability",
	Cooldown = 8,
	Rotation = {"None", "None", "None", "None", "None"},
};
ICoorM.Table = {};
for i = 1, 5 do
	ICoorM.Table[i] = {
		Name = "None",
		Finish = i / 10,
	};
end

function ICoorM:LoadFight(i)
	if ICoorM_Fight.Enabled == false then return end
	self.CurrentFight = ICoorM_Fight[i];
	local c = self.CurrentFight;
	if c ~= nil then
		SendAddonMessage("ICoor", "fight_" ..c.Spell .."_" ..c.Rotation[1] .."_" ..c.Rotation[2] .."_" ..c.Rotation[3] .."_" ..c.Rotation[4] .."_" ..c.Rotation[5], ICoorSendType);
		self.Table = {};
		for i = 1, 5 do
			if c.Rotation[i] ~= "None" then
				self.Table[i] = {
					Name = c.Rotation[i],
					Finish = i / 10,
				};
			end
		end
	end
end

local function InList(name)
	for i = 1, 5 do
		if ICoorM.CurrentFight.Rotation[i] == name then
			return true;
		end
	end
	return false;
end

local function sorter(a, b)
	return a.Finish < b.Finish;
end

local function SendList()
	table.sort(ICoorM.Table, sorter);
	c = ICoorM.Table;
	local message = "list";
	for i = 1, 5 do
		if ICoorM.Table[i] ~= nil then
			message = message .."_" ..ICoorM.Table[i].Name;
		else
			message = message .."_None";
		end
	end
	SendAddonMessage("ICoor", message, ICoorSendType);
end

local function UpdateEndTime(name, time)
	for i = 1, table.getn(ICoorM.Table) do
		if ICoorM.Table[i].Name == name then
			ICoorM.Table[i].Finish = time;
			return;
		end
	end
end

local function OnEvent(self, event, arg1, arg2)
	if event == "CHAT_MSG_ADDON" then
		if ICoorM_Fight.Enabled == false then return end
		words = {}
		for word in arg2:gmatch("([^_]+)") do table.insert(words, word) end
		if InList(words[2]) then
			if words[1] == "cd" then
				UpdateEndTime(words[2], (GetTime() * 1000) + tonumber(words[3]));
				SendList();
			end
		end
	elseif event == "ADDON_LOADED" then
		if arg1 == "InterruptCoordinator" then
			if ICoorM_Fight == nil then
				ICoorM_Fight = {
					[1] = {
						Name = "Test Fight",
						Spell = "Bash",
						Rotation = {"None", "None", "None", "None", "None"},
					},
					Enabled = false;
				};
			end
		end
	end
end
ICoorM:RegisterEvent("CHAT_MSG_ADDON");
ICoorM:RegisterEvent("ADDON_LOADED");
ICoorM:SetScript("OnEvent", OnEvent);
